Attribute VB_Name = "modCache"
Public Declare Function EncryptDataString Lib "odysseydll" (ByRef File As Any, ByVal XorValue As Byte) As Long

Function LoadMapFromCache(LoadMap As Long) As String
    ChDir App.Path
    CurDir App.Path
    Dim MapData As String * 2677

    Open "cache1.dat" For Random As #1 Len = 2677
    Get #1, LoadMap, MapData
    Close #1
    
    If Asc(Mid$(MapData, 1, 1)) > 0 Then
        Dim MapDataWorkingArray() As Byte
        MapDataWorkingArray() = StrConv(MapData, vbFromUnicode)
        EncryptDataString MapDataWorkingArray(0), LoadMap * 16 Mod 50 + 5
        MapData = StrConv(MapDataWorkingArray, vbUnicode)
    End If
    LoadMapFromCache = MapData
    
End Function

Sub LoadObject(TheObj As Integer)
    Dim St As String * 27
    Open "ocache.dat" For Random As #1 Len = 27
    Get #1, TheObj, St
    Close #1
    With Object(TheObj)
        .name = ClipString$(Mid$(St, 1, 15))
        .Picture = Asc(Mid$(St, 16, 1)) * 256 + Asc(Mid$(St, 17, 1))
        .Type = Asc(Mid$(St, 18, 1))
        Select Case .Type
        Case 8    'Ring
            .MaxDur = Asc(Mid$(St, 20, 1))
            .Data2 = Asc(Mid$(St, 19, 1))
            .Modifier = Asc(Mid$(St, 21, 1))
        Case 10, 11    'Projectile Weapon
            .Modifier = Asc(Mid$(St, 19, 1))
            .Data2 = Asc(Mid$(St, 21, 1))
        Case Else
            .MaxDur = Asc(Mid$(St, 19, 1))
            .Modifier = Asc(Mid$(St, 20, 1))
            .Data2 = Asc(Mid$(St, 21, 1))
        End Select
        .flags = Asc(Mid$(St, 22, 1))
        .ClassReq = Asc(Mid$(St, 23, 1))
        .LevelReq = Asc(Mid$(St, 24, 1))
        .Version = Asc(Mid$(St, 25, 1))
        .SellPrice = Asc(Mid$(St, 26, 1)) * 256 + Asc(Mid$(St, 27, 1))
    End With
End Sub

Sub LoadNPC(TheNPC As Integer)
    Dim St As String * 137
    Dim A As Long, B As Long
    Open "ncache.dat" For Random As #1 Len = 137
    Get #1, TheNPC, St
    Close #1
    With NPC(TheNPC)
        .name = ClipString$(Mid$(St, 1, 15))
        .Version = Asc(Mid$(St, 16, 1))
        .flags = Asc(Mid$(St, 17, 1))
        For A = 0 To 9
            B = 18 + A * 12
            .SaleItem(A).GiveObject = Asc(Mid$(St, B, 1)) * 256& + Asc(Mid$(St, B + 1, 1))
            .SaleItem(A).GiveValue = Asc(Mid$(St, B + 2, 1)) * 16777216 + Asc(Mid$(St, B + 3, 1)) * 65536 + Asc(Mid$(St, B + 4, 1)) * 256& + Asc(Mid$(St, B + 5, 1))
            .SaleItem(A).TakeObject = Asc(Mid$(St, B + 6, 1)) * 256& + Asc(Mid$(St, B + 7, 1))
            .SaleItem(A).TakeValue = Asc(Mid$(St, B + 8, 1)) * 16777216 + Asc(Mid$(St, B + 9, 1)) * 65536 + Asc(Mid$(St, B + 10, 1)) * 256& + Asc(Mid$(St, B + 11, 1))
        Next A
    End With
End Sub

Sub LoadHall(TheHall As Integer)
    Dim St As String * 16
    Open "hcache.dat" For Random As #1 Len = 16
    Get #1, TheHall, St
    Close #1
    With Hall(TheHall)
        .name = ClipString$(Mid$(St, 1, 15))
        .Version = Asc(Mid$(St, 16, 1))
    End With
End Sub

Sub LoadMonster(TheMonster As Integer)
    Dim St As String * 21
    Open "moncache.dat" For Random As #1 Len = 21
    Get #1, TheMonster, St
    Close #1
    With Monster(TheMonster)
        .name = ClipString$(Mid$(St, 1, 15))
        .Sprite = Asc(Mid$(St, 16, 1)) * 256 + Asc(Mid$(St, 17, 1))
        .Version = Asc(Mid$(St, 18, 1))
        .MaxLife = GetInt(Mid$(St, 19, 2))
        .flags = Asc(Mid$(St, 21, 1))
    End With
End Sub

Sub LoadMagic(TheMagic As Integer)
    Dim St As String * 124
    Open "magcache.dat" For Random As #1 Len = 124
    Get #1, TheMagic, St
    Close #1
    With Magic(TheMagic)
        .name = ClipString$(Mid$(St, 1, 15))
        .Version = Asc(Mid$(St, 16, 1))
        If .Version > 0 Then
            .Level = Asc(Mid$(St, 17, 1))
            .Class = Asc(Mid$(St, 18, 1))
            .Icon = Asc(Mid$(St, 19, 1)) * 256 + Asc(Mid$(St, 20, 1))
            .IconType = Asc(Mid$(St, 21, 1))
            .CastTimer = Asc(Mid$(St, 22, 1)) * 256 + Asc(Mid$(St, 23, 1))
            .Description = ClipString$(Mid$(St, 24, 100))
        End If
    End With
End Sub

Sub LoadPrefix(ThePrefix As Integer)
    Dim St As String * 19
    Open "itemprecache.dat" For Random As #1 Len = 19
    Get #1, ThePrefix, St
    Close #1
    With ItemPrefix(ThePrefix)
        .name = ClipString$(Mid$(St, 1, 15))
        .Version = Asc(Mid$(St, 16, 1))
        .ModificationType = Asc(Mid$(St, 17, 1))
        .ModificationValue = Asc(Mid$(St, 18, 1))
        .OccursNaturally = Asc(Mid$(St, 19, 1))
    End With
End Sub

Sub LoadSuffix(TheSuffix As Integer)
    Dim St As String * 19
    Open "itemsufcache.dat" For Random As #1 Len = 19
    Get #1, TheSuffix, St
    Close #1
    With ItemSuffix(TheSuffix)
        .name = ClipString$(Mid$(St, 1, 15))
        .Version = Asc(Mid$(St, 16, 1))
        .ModificationType = Asc(Mid$(St, 17, 1))
        .ModificationValue = Asc(Mid$(St, 18, 1))
        .OccursNaturally = Asc(Mid$(St, 19, 1))
    End With
End Sub

