Attribute VB_Name = "modConstants"
Option Explicit

'Editing Mode Constants
Public ListEditMode As Byte
Public Const modeObjects = 1
Public Const modeMonsters = 2
Public Const modeNPCs = 3
Public Const modeHalls = 4
Public Const modeMagic = 5
Public Const modeBans = 6
Public Const modePrefix = 7
Public Const modeSuffix = 8
Public Const modeAbility = 9
Public Const modeSkill = 10

'Maximum Constants
Public Const MaxSprite = 643
Public Const MaxMonsters = 1000
Public Const MaxMaps = 3000
Public Const MaxNPCs = 500
Public Const MaxMagic = 500
Public Const MaxGuilds = 255
Public Const MaxHalls = 255
Public Const MaxModifications = 255
Public Const MaxTotalMonsters = 1000
Public Const MaxObjects = 1000
Public Const MaxAtt = 22
Public Const NumClasses = 4
Public Const MaxUsers = 80
Public Const MaxProjectiles = 20
Public Const MaxFloatText = 20
Public Const MaxInvObjects = 20
Public Const MaxMapObjects = 79
Public Const MaxSkill = 10
Public Const MaxRequestLength = 200

'Hacking Code Constant
Public Const HackCode = 98

'Projectile Type Constants
Public Const pttCharacter = 0
Public Const pttPlayer = 1
Public Const pttMonster = 2
Public Const pttTile = 3
Public Const pttProject = 4

'Color Constants
Public Const BLACK = 0
Public Const BLUE = 1
Public Const GREEN = 2
Public Const CYAN = 3
Public Const RED = 4
Public Const MAGENTA = 5
Public Const BROWN = 6
Public Const GREY = 7
Public Const DARKGREY = 8
Public Const BRIGHTBLUE = 9
Public Const BRIGHTGREEN = 10
Public Const BRIGHTCYAN = 11
Public Const BRIGHTRED = 12
Public Const BRIGHTMAGENTA = 13
Public Const YELLOW = 14
Public Const WHITE = 15

'API CONSTANTS

'SetBkMode Constants
Public Const Transparent = 1

'BitBlt Constants
Public Const BLACKNESS = &H42
Public Const WHITENESS = &HFF0062
Public Const SRCCOPY = &HCC0020
Public Const SRCPAINT = &HEE0086
Public Const SRCAND = &H8800C6
Public Const NOTSRCCOPY = &H330008
Public Const SRCINVERT = &H660046
Public Const DSTINVERT = &H550009

'DrawText Constants
Public Const DT_TOP = &H0
Public Const DT_LEFT = &H0
Public Const DT_CENTER = &H1
Public Const DT_RIGHT = &H2
Public Const DT_VCENTER = &H4
Public Const DT_BOTTOM = &H8
Public Const DT_WORDBREAK = &H10
Public Const DT_SINGLELINE = &H20
Public Const DT_EXPANDTABS = &H40
Public Const DT_TABSTOP = &H80
Public Const DT_NOCLIP = &H100
Public Const DT_EXTERNALLEADING = &H200
Public Const DT_CALCRECT = &H400
Public Const DT_NOPREFIX = &H800
Public Const DT_INTERNAL = &H1000


'SendMessage Constants
Public Const EM_LINEINDEX = &HBB
Public Const EM_LINELENGTH = &HC1

Public Const WM_NCLBUTTONDOWN = &HA1
Public Const HTCAPTION = 2


'WaitForTerm (Used by Scripting)
Public Const SYNCHRONIZE = &H100000
Public Const INFINITE = &HFFFFFFFF

'Bitmap File Header
Public Type BITMAPINFOHEADER2    '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Public Type BITMAPFILEHEADER
    bfType As Integer
    bfSize As Long
    bfReserved1 As Integer
    bfReserved2 As Integer
    bfOhFileBits As Long
End Type

'GetQueueStatus constants
Public Const QS_HOTKEY = &H80
Public Const QS_KEY = &H1
Public Const QS_MOUSEBUTTON = &H4
Public Const QS_MOUSEMOVE = &H2
Public Const QS_PAINT = &H20
Public Const QS_POSTMESSAGE = &H8
Public Const QS_SENDMESSAGE = &H40
Public Const QS_TIMER = &H10
Public Const QS_ALLINPUT = (QS_SENDMESSAGE Or QS_PAINT Or _
                            QS_TIMER Or QS_POSTMESSAGE Or QS_MOUSEBUTTON Or QS_MOUSEMOVE Or _
                            QS_HOTKEY Or QS_KEY)
Public Const QS_MOUSE = (QS_MOUSEMOVE Or QS_MOUSEBUTTON)
Public Const QS_INPUT = (QS_MOUSE Or QS_KEY)
Public Const QS_ALLEVENTS = (QS_INPUT Or QS_POSTMESSAGE Or QS_TIMER Or QS_PAINT Or QS_HOTKEY)

'Key Constants
Public Const vbKeyAlt = vbKeyControl + 1

Public ReceiveArray(0 To 255) As Long

Type NPCSaleItemData
    GiveObject As Integer
    GiveValue As Long
    TakeObject As Integer
    TakeValue As Long
End Type

Type ItemBankData
    Object As Integer
    value As Long
    ItemPrefix As Byte
    ItemSuffix As Byte
End Type

Type SkillData
    Level As Byte
    Experience As Long
End Type

Type HotkeyData
    Hotkey As Byte
Type As Byte
    ScrollPosition As Byte
End Type

Type ProjectileData
    Sprite As Integer
    Type As Byte
    Frame As Byte
    TotalFrames As Integer
    TargetType As Byte
    TargetNum As Byte
    TargetX As Long
    TargetY As Long
    SourceX As Byte
    SourceY As Byte
    X As Long
    Y As Long
    TimeStamp As Long
    LoopCount As Integer
    CurLoop As Integer
    speed As Long
    EndSound As Long
    offset As Byte
    Creator As Byte
    Magic As Byte
    Damage As Byte
    Alternate As Boolean
End Type

Type PlayerData
    name As String
    LastMessage As String
    RepCount As Long
    Map As Long
    Sprite As Integer
    status As Byte
    X As Byte
    Y As Byte
    XO As Long
    YO As Long
    D As Byte
    A As Byte
    W As Long
    WalkStep As Long
    Guild As Byte
    Color As Long
    Ignore As Boolean
    IsDead As Boolean
    HP As Byte
    MaxHP As Byte
End Type

Type MacroData
    Text As String
    LineFeed As Boolean
End Type

Type objectData
    name As String
    Type As Byte
    flags As Byte
    Picture As Integer
    Modifier As Byte
    Data2 As Byte
    MaxDur As Byte
    ClassReq As Byte
    LevelReq As Byte
    Version As Byte
    SellPrice As Integer
End Type

Type MonsterData
    name As String
    Sprite As Integer
    Version As Byte
    MaxLife As Integer
    flags As Byte
End Type

Type MapStartLocationData
    Map As Integer
    X As Byte
    Y As Byte
End Type

Type MapDoorData
    Att As Byte
    BGTile1 As Integer
    X As Byte
    Y As Byte
End Type

Type TileData
    Ground As Integer
    Ground2 As Integer
    BGTile1 As Integer
    BGTile2 As Integer
    FGTile As Integer
    FGTile2 As Integer
    Att As Byte
    AttData(0 To 3) As Byte
    Att2 As Byte
End Type

Type MapMonsterData
    Monster As Integer
    Life As Integer
    X As Byte
    Y As Byte
    XO As Long
    YO As Long
    D As Byte
    A As Byte
    W As Byte
    HPBar As Boolean
End Type

Type MapObjectData
    Object As Integer
    X As Byte
    Y As Byte
    XOffset As Byte
    YOffset As Byte
    ItemPrefix As Byte
    ItemSuffix As Byte
    value As Long
    PickedUp As Long
End Type

Type MapMonsterSpawnData
    Monster As Integer
    Rate As Byte
End Type

Type MapData
    name As String
    ExitUp As Integer
    ExitDown As Integer
    ExitLeft As Integer
    ExitRight As Integer
    Tile(0 To 11, 0 To 11) As TileData
    Object(0 To MaxMapObjects) As MapObjectData
    Monster(0 To MaxMonsters) As MapMonsterData
    MonsterSpawn(0 To 9) As MapMonsterSpawnData
    Door(0 To 9) As MapDoorData
    BootLocation As MapStartLocationData
    DeathLocation As MapStartLocationData
    NPC As Integer
    MIDI As Byte
    flags As Byte
    Flags2 As Byte
    Version As Long
End Type

Type InvObjData
    Object As Integer
    value As Long
    EquippedNum As Byte
    ItemPrefix As Byte
    ItemSuffix As Byte
End Type

Type GuildData
    name As String
    MemberCount As Byte
End Type

Type MagicData
    name As String
    MagicLevel As Byte
    MagicExperience As Long
    Level As Byte
    Class As Byte
    Version As Byte
    Description As String
    Icon As Integer
    IconType As Byte
    CastTimer As Integer
End Type

Type HallData
    name As String
    Version As Byte
End Type

Type NPCData
    name As String
    Version As Byte
    flags As Byte
    SaleItem(0 To 9) As NPCSaleItemData
End Type

Type EquippedObjectData
    Object As Integer
    value As Long
    ItemPrefix As Byte
    ItemSuffix As Byte
End Type

Type GuildDeclarationData
    Guild As Byte
    Type As Byte
End Type

Type CharacterData
    name As String
    Class As Byte
    Gender As Byte
    Sprite As Integer

    MaxHP As Byte
    MaxEnergy As Byte
    MaxMana As Byte

    Experience As Long
    Level As Byte
    StatPoints As Integer

    PhysicalAttack As Byte
    PhysicalDefense As Byte
    MagicDefense As Byte

    Skill(1 To 10) As SkillData
    Hotkey(1 To 12) As HotkeyData
    ItemBank(0 To 29) As ItemBankData

    status As Byte
    Access As Byte
    index As Byte
    Guild As Byte
    GuildRank As Byte

    Projectile As Boolean
    Ammo As Byte

    IsDead As Boolean
    LastMove As Long
    SpeedTick As Long
    EnergyTick As Long

    GuildDeclaration(0 To 4) As GuildDeclarationData
    EquippedObject(1 To 5) As EquippedObjectData

    Desc As String
    Inv(1 To MaxInvObjects) As InvObjData
End Type

Type ClassData
    name As String
    StartHP As Byte
    StartEnergy As Byte
    StartMana As Byte
End Type

Type FloatTextData
    Text As String
    Color As Byte
    Static As Boolean
    X As Byte
    Y As Byte
    FloatY As Integer
    InUse As Boolean
End Type

Type PrefixData
    name As String
    ModificationType As Byte
    ModificationValue As Byte
    OccursNaturally As Byte
    Version As Byte
End Type

Type WorldProperties
    StatStrength As Byte
    StatEndurance As Byte
    StatIntelligence As Byte
    StatConcentration As Byte
    StatConstitution As Byte
    StatStamina As Byte
    StatWisdom As Byte
    ObjMoney As Byte
    Cost_Per_Durability As Integer
    Cost_Per_Strength As Integer
    Cost_Per_Modifier As Integer
    GuildJoinLevel As Byte
    GuildNewLevel As Byte
    GuildJoinCost As Long
    GuildNewCost As Long
End Type

Public Map As MapData, EditMap As MapData
Public StatusColors(0 To 100) As Long
Public Player(1 To MaxUsers) As PlayerData
Public Magic(1 To MaxMagic) As MagicData
Public Projectile(1 To MaxProjectiles) As ProjectileData
Public Monster(1 To MaxTotalMonsters) As MonsterData
Public Object(1 To MaxObjects) As objectData
Public Class(1 To NumClasses) As ClassData
Public Guild(1 To MaxGuilds) As GuildData
Public Hall(1 To MaxHalls) As HallData
Public NPC(1 To MaxNPCs) As NPCData
Public ItemPrefix(1 To MaxModifications) As PrefixData
Public ItemSuffix(1 To MaxModifications) As PrefixData
Public Character As CharacterData
Public Macro(0 To 9) As MacroData
Public World As WorldProperties




