Attribute VB_Name = "modMain"
Public WS As Workspace
Public DB As Database
Public UserRS As Recordset
Public NPCRS As Recordset
Public MonsterRS As Recordset
Public MagicRS As Recordset
Public ObjectRS As Recordset
Public DataRS As Recordset
Public MapRS As Recordset
Public GuildRS As Recordset
Public MsgRS As Recordset
Public PostRS As Recordset
Public BanRS As Recordset
Public HallRS As Recordset
Public ScriptRS As Recordset
Public GodRS As Recordset


Sub Main()
    Set WS = DBEngine.Workspaces(0)
    If Exists("server.tmp") Then Kill "server.tmp"
    Name "server.dat" As "server.tmp"
    RepairDatabase "server.tmp"
    CompactDatabase "server.tmp", "server.dat", , 0, ";pwd=" + "ontario"
    Set DB = WS.OpenDatabase("server.dat", 0, False, ";pwd=ontario")
    
    'On Error Resume Next
    
    Set UserRS = DB.TableDefs("Accounts").OpenRecordset(dbOpenTable)
    Set NPCRS = DB.TableDefs("NPCs").OpenRecordset(dbOpenTable)
    Set MonsterRS = DB.TableDefs("Monsters").OpenRecordset(dbOpenTable)
    Set ObjectRS = DB.TableDefs("Objects").OpenRecordset(dbOpenTable)
    Set MapRS = DB.TableDefs("Maps").OpenRecordset(dbOpenTable)
    Set BanRS = DB.TableDefs("Bans").OpenRecordset(dbOpenTable)
    Set GuildRS = DB.TableDefs("Guilds").OpenRecordset(dbOpenTable)
    Set HallRS = DB.TableDefs("Halls").OpenRecordset(dbOpenTable)
    Set ScriptRS = DB.TableDefs("Scripts").OpenRecordset(dbOpenTable)
    Set MagicRS = DB.TableDefs("Magic").OpenRecordset(dbOpenTable)
    
    Dim A As Long
    UserRS.index = "User"
    ObjectRS.index = "Number"
    NPCRS.index = "Number"
    MonsterRS.index = "Number"
    MapRS.index = "Number"
    BanRS.index = "Number"
    GuildRS.index = "Number"
    HallRS.index = "Number"
    ScriptRS.index = "Name"
    MagicRS.index = "Number"
    
    Dim numMaps As Integer, cache As String, mapNum As Long
    
    ' Convert the map cache
    If Exists("cache1.dat") Then
        For mapNum = 1 To MaxMaps
            cache = LoadMapFromCache(mapNum)
            If Asc(Mid$(cache, 1, 1)) > 0 Then
                 MapRS.Seek "=", mapNum
                 If MapRS.NoMatch Then
                     MapRS.AddNew
                     MapRS!Number = mapNum
                 Else
                     MapRS.Edit
                 End If
                
                 MapRS!data = CompressString$(cache)
                 MapRS.Update
            End If
        Next mapNum
    End If
    
    Dim objectNum As Integer
    
    ' Convert the object cache
    If Exists("ocache.dat") Then
        For objectNum = 1 To MaxObjects
            LoadObject (objectNum)
            If Len(Object(objectNum).name) > 0 Then
                 ObjectRS.Seek "=", objectNum
                 If ObjectRS.NoMatch Then
                     ObjectRS.AddNew
                     ObjectRS!Number = objectNum
                 Else
                     ObjectRS.Edit
                 End If
                 
                 ObjectRS!name = Object(objectNum).name
                 ObjectRS!Picture = Object(objectNum).Picture
                 ObjectRS!Type = Object(objectNum).Type
                 ObjectRS!Data1 = Object(objectNum).MaxDur
                 ObjectRS!Data2 = Object(objectNum).Modifier
                 ObjectRS!Data3 = Object(objectNum).Data2
                 ObjectRS!Data4 = 0
                 ObjectRS!ClassReq = Object(objectNum).ClassReq
                 ObjectRS!LevelReq = Object(objectNum).LevelReq
                 ObjectRS!SellPrice = Object(objectNum).SellPrice
                 ObjectRS!Version = Object(objectNum).Version
                 ObjectRS!flags = Object(objectNum).flags
                 ObjectRS.Update
            End If
        Next objectNum
    End If
    
    Dim monNum As Integer
    ' Convert the monster cache
    If Exists("moncache.dat") Then
        For monNum = 1 To MaxMonsters
            LoadMonster (monNum)
            If Len(Monster(monNum).name) > 0 Then
                 MonsterRS.Seek "=", monNum
                 If MonsterRS.NoMatch Then
                     MonsterRS.AddNew
                     MonsterRS!Number = monNum
                 Else
                     MonsterRS.Edit
                 End If
                 
                 MonsterRS!name = Monster(monNum).name
                 MonsterRS!Sprite = Monster(monNum).Sprite
                 MonsterRS!HP = Monster(monNum).MaxLife
                 MonsterRS!Strength = 0
                 MonsterRS!Armor = 0
                 MonsterRS!speed = 0
                 MonsterRS!Sight = 0
                 MonsterRS!Agility = 0
                 MonsterRS!flags = Monster(monNum).flags
                 MonsterRS!Experience = 0
                 MonsterRS!MagicDefense = 0
                 MonsterRS!Version = Monster(monNum).Version
                 MonsterRS!Object0 = 0
                 MonsterRS!Value0 = 0
                 MonsterRS!Object1 = 0
                 MonsterRS!Value1 = 0
                 MonsterRS!Object2 = 0
                 MonsterRS!Value2 = 0
                 MonsterRS.Update
            End If
        Next monNum
    End If
    
    Dim npcNum As Integer
    ' Convert the npc cache
    If Exists("ncache.dat") Then
        For npcNum = 1 To MaxNPCs
            LoadNPC (npcNum)
            If Len(NPC(npcNum).name) > 0 Then
                 NPCRS.Seek "=", npcNum
                 If NPCRS.NoMatch Then
                     NPCRS.AddNew
                     NPCRS!Number = npcNum
                 Else
                     NPCRS.Edit
                 End If
                 
                 NPCRS!name = NPC(npcNum).name
                 NPCRS!Version = NPC(npcNum).Version
                 NPCRS!GiveObject0 = NPC(npcNum).SaleItem(0).GiveObject
                 NPCRS!GiveValue0 = NPC(npcNum).SaleItem(0).GiveValue
                 NPCRS!TakeObject0 = NPC(npcNum).SaleItem(0).TakeObject
                 NPCRS!TakeValue0 = NPC(npcNum).SaleItem(0).TakeValue
                 
                 NPCRS!GiveObject1 = NPC(npcNum).SaleItem(1).GiveObject
                 NPCRS!GiveValue1 = NPC(npcNum).SaleItem(1).GiveValue
                 NPCRS!TakeObject1 = NPC(npcNum).SaleItem(1).TakeObject
                 NPCRS!TakeValue1 = NPC(npcNum).SaleItem(1).TakeValue
                 
                 NPCRS!GiveObject2 = NPC(npcNum).SaleItem(2).GiveObject
                 NPCRS!GiveValue2 = NPC(npcNum).SaleItem(2).GiveValue
                 NPCRS!TakeObject2 = NPC(npcNum).SaleItem(2).TakeObject
                 NPCRS!TakeValue2 = NPC(npcNum).SaleItem(2).TakeValue
                 
                 NPCRS!GiveObject3 = NPC(npcNum).SaleItem(3).GiveObject
                 NPCRS!GiveValue3 = NPC(npcNum).SaleItem(3).GiveValue
                 NPCRS!TakeObject3 = NPC(npcNum).SaleItem(3).TakeObject
                 NPCRS!TakeValue3 = NPC(npcNum).SaleItem(3).TakeValue
                 
                 NPCRS!GiveObject4 = NPC(npcNum).SaleItem(4).GiveObject
                 NPCRS!GiveValue4 = NPC(npcNum).SaleItem(4).GiveValue
                 NPCRS!TakeObject4 = NPC(npcNum).SaleItem(4).TakeObject
                 NPCRS!TakeValue4 = NPC(npcNum).SaleItem(4).TakeValue
                 
                 NPCRS!GiveObject5 = NPC(npcNum).SaleItem(5).GiveObject
                 NPCRS!GiveValue5 = NPC(npcNum).SaleItem(5).GiveValue
                 NPCRS!TakeObject5 = NPC(npcNum).SaleItem(5).TakeObject
                 NPCRS!TakeValue5 = NPC(npcNum).SaleItem(5).TakeValue
                 
                 NPCRS!GiveObject6 = NPC(npcNum).SaleItem(6).GiveObject
                 NPCRS!GiveValue6 = NPC(npcNum).SaleItem(6).GiveValue
                 NPCRS!TakeObject6 = NPC(npcNum).SaleItem(6).TakeObject
                 NPCRS!TakeValue6 = NPC(npcNum).SaleItem(6).TakeValue
                 
                 NPCRS!GiveObject7 = NPC(npcNum).SaleItem(7).GiveObject
                 NPCRS!GiveValue7 = NPC(npcNum).SaleItem(7).GiveValue
                 NPCRS!TakeObject7 = NPC(npcNum).SaleItem(7).TakeObject
                 NPCRS!TakeValue7 = NPC(npcNum).SaleItem(7).TakeValue
                 
                 NPCRS!GiveObject8 = NPC(npcNum).SaleItem(8).GiveObject
                 NPCRS!GiveValue8 = NPC(npcNum).SaleItem(8).GiveValue
                 NPCRS!TakeObject8 = NPC(npcNum).SaleItem(8).TakeObject
                 NPCRS!TakeValue8 = NPC(npcNum).SaleItem(8).TakeValue
                 
                 NPCRS!GiveObject9 = NPC(npcNum).SaleItem(9).GiveObject
                 NPCRS!GiveValue9 = NPC(npcNum).SaleItem(9).GiveValue
                 NPCRS!TakeObject9 = NPC(npcNum).SaleItem(9).TakeObject
                 NPCRS!TakeValue9 = NPC(npcNum).SaleItem(9).TakeValue
                 
                 NPCRS!jointext = ""
                 NPCRS!leavetext = ""
                 NPCRS!saytext0 = ""
                 NPCRS!saytext1 = ""
                 NPCRS!saytext2 = ""
                 NPCRS!saytext3 = ""
                 NPCRS!saytext4 = ""
                 
                 
                 NPCRS!flags = NPC(npcNum).flags
                 
                 
                 NPCRS.Update
            End If
        Next npcNum
    End If
    
    Dim magNum As Integer
    If Exists("magcache.dat") Then
        For magNum = 1 To MaxMagic
            LoadMagic (magNum)
            If Len(Magic(magNum).name) > 0 Then
                 MagicRS.Seek "=", magNum
                 If MagicRS.NoMatch Then
                     MagicRS.AddNew
                     MagicRS!Number = magNum
                 Else
                     MagicRS.Edit
                 End If
                 
                 MagicRS!name = Magic(magNum).name
                 MagicRS!Level = Magic(magNum).Level
                 MagicRS!Class = Magic(magNum).Class
                 MagicRS!Version = Magic(magNum).Version
                 MagicRS!Icon = Magic(magNum).Icon
                 MagicRS!IconType = Magic(magNum).IconType
                 MagicRS!CastTimer = Magic(magNum).CastTimer
                 MagicRS!Description = Magic(magNum).Description
                 MagicRS.Update
            End If
        Next magNum
    End If
    
    Kill "server.tmp"
    MsgBox "Success! The cache has been successful extracted to your server.dat"
End Sub

Function Exists(Filename As String) As Boolean
     Exists = (Dir(Filename) <> "")
End Function

Function ClipString(St As String) As String
    Dim A As Long
    For A = Len(St) To 1 Step -1
        If Mid$(St, A, 1) <> Chr$(32) And Mid$(St, A, 1) <> Chr$(0) Then
            ClipString = Mid$(St, 1, A)
            Exit Function
        End If
    Next A
End Function

Function GetInt(Chars As String) As Long
    GetInt = Asc(Mid$(Chars, 1, 1)) * 256 + Asc(Mid$(Chars, 2, 1))
End Function

