Attribute VB_Name = "modMap"
Option Explicit
Type NPCSaleItemData
    GiveObject As Integer
    GiveValue As Long
    TakeObject As Integer
    TakeValue As Long
End Type

Type ItemBankData
    Object As Integer
    value As Long
    ItemPrefix As Byte
    ItemSuffix As Byte
End Type

Type SkillData
    Level As Byte
    Experience As Long
End Type

Type HotkeyData
    Hotkey As Byte
Type As Byte
    ScrollPosition As Byte
End Type

Type ProjectileData
    Sprite As Integer
    Type As Byte
    Frame As Byte
    TotalFrames As Integer
    TargetType As Byte
    TargetNum As Byte
    TargetX As Long
    TargetY As Long
    SourceX As Byte
    SourceY As Byte
    X As Long
    Y As Long
    TimeStamp As Long
    LoopCount As Integer
    CurLoop As Integer
    speed As Long
    EndSound As Long
    offset As Byte
    Creator As Byte
    Magic As Byte
    Damage As Byte
    Alternate As Boolean
End Type

Type PlayerData
    name As String
    LastMessage As String
    RepCount As Long
    Map As Long
    Sprite As Integer
    status As Byte
    X As Byte
    Y As Byte
    XO As Long
    YO As Long
    D As Byte
    A As Byte
    W As Long
    WalkStep As Long
    Guild As Byte
    Color As Long
    Ignore As Boolean
    IsDead As Boolean
    HP As Byte
    MaxHP As Byte
End Type

Type MacroData
    Text As String
    LineFeed As Boolean
End Type

Type ObjectData
    name As String
    Type As Byte
    flags As Byte
    Picture As Integer
    Modifier As Byte
    Data2 As Byte
    MaxDur As Byte
    ClassReq As Byte
    LevelReq As Byte
    Version As Byte
    SellPrice As Integer
End Type

Type MonsterData
    name As String
    Sprite As Integer
    Version As Byte
    MaxLife As Integer
    flags As Byte
End Type

Type MapStartLocationData
    Map As Integer
    X As Byte
    Y As Byte
End Type

Type MapDoorData
    Att As Byte
    BGTile1 As Integer
    X As Byte
    Y As Byte
End Type

Type TileData
    Ground As Integer
    Ground2 As Integer
    BGTile1 As Integer
    BGTile2 As Integer
    FGTile As Integer
    FGTile2 As Integer
    Att As Byte
    AttData(0 To 3) As Byte
    Att2 As Byte
End Type

Type MapMonsterData
    Monster As Integer
    Life As Integer
    X As Byte
    Y As Byte
    XO As Long
    YO As Long
    D As Byte
    A As Byte
    W As Byte
    HPBar As Boolean
End Type

Type MapObjectData
    Object As Integer
    X As Byte
    Y As Byte
    XOffset As Byte
    YOffset As Byte
    ItemPrefix As Byte
    ItemSuffix As Byte
    value As Long
    PickedUp As Long
End Type

Type MapMonsterSpawnData
    Monster As Integer
    Rate As Byte
End Type

Type MapData
    name As String
    ExitUp As Integer
    ExitDown As Integer
    ExitLeft As Integer
    ExitRight As Integer
    Tile(0 To 11, 0 To 11) As TileData
    Object(0 To MaxMapObjects) As MapObjectData
    Monster(0 To MaxMonsters) As MapMonsterData
    MonsterSpawn(0 To 9) As MapMonsterSpawnData
    Door(0 To 9) As MapDoorData
    BootLocation As MapStartLocationData
    DeathLocation As MapStartLocationData
    NPC As Integer
    MIDI As Byte
    flags As Byte
    Flags2 As Byte
    Version As Long
End Type

Type InvObjData
    Object As Integer
    value As Long
    EquippedNum As Byte
    ItemPrefix As Byte
    ItemSuffix As Byte
End Type

Type GuildData
    name As String
    MemberCount As Byte
End Type

Type MagicData
    name As String
    MagicLevel As Byte
    MagicExperience As Long
    Level As Byte
    Class As Byte
    Version As Byte
    Description As String
    Icon As Integer
    IconType As Byte
    CastTimer As Integer
End Type

Type HallData
    name As String
    Version As Byte
End Type

Type NPCData
    name As String
    Version As Byte
    flags As Byte
    SaleItem(0 To 9) As NPCSaleItemData
End Type

Type EquippedObjectData
    Object As Integer
    value As Long
    ItemPrefix As Byte
    ItemSuffix As Byte
End Type

Type GuildDeclarationData
    Guild As Byte
    Type As Byte
End Type

Type CharacterData
    name As String
    Class As Byte
    Gender As Byte
    Sprite As Integer

    MaxHP As Byte
    MaxEnergy As Byte
    MaxMana As Byte

    Experience As Long
    Level As Byte
    StatPoints As Integer

    PhysicalAttack As Byte
    PhysicalDefense As Byte
    MagicDefense As Byte

    Skill(1 To 10) As SkillData
    Hotkey(1 To 12) As HotkeyData
    ItemBank(0 To 29) As ItemBankData

    status As Byte
    Access As Byte
    index As Byte
    Guild As Byte
    GuildRank As Byte

    Projectile As Boolean
    Ammo As Byte

    IsDead As Boolean
    LastMove As Long
    SpeedTick As Long
    EnergyTick As Long

    GuildDeclaration(0 To 4) As GuildDeclarationData
    EquippedObject(1 To 5) As EquippedObjectData

    Desc As String
    Inv(1 To MaxInvObjects) As InvObjData
End Type

Type ClassData
    name As String
    StartHP As Byte
    StartEnergy As Byte
    StartMana As Byte
End Type

Type FloatTextData
    Text As String
    Color As Byte
    Static As Boolean
    X As Byte
    Y As Byte
    FloatY As Integer
    InUse As Boolean
End Type

Type PrefixData
    name As String
    ModificationType As Byte
    ModificationValue As Byte
    OccursNaturally As Byte
    Version As Byte
End Type

Type WorldProperties
    StatStrength As Byte
    StatEndurance As Byte
    StatIntelligence As Byte
    StatConcentration As Byte
    StatConstitution As Byte
    StatStamina As Byte
    StatWisdom As Byte
    ObjMoney As Byte
    Cost_Per_Durability As Integer
    Cost_Per_Strength As Integer
    Cost_Per_Modifier As Integer
    GuildJoinLevel As Byte
    GuildNewLevel As Byte
    GuildJoinCost As Long
    GuildNewCost As Long
End Type
Sub OpenMap(File As String)
    Dim TheMapData As String * 2677

    Open File For Binary As #15
    Get #15, 1, TheMapData
    Close #15

    ChDir App.Path
    CurDir App.Path

    LoadEditMap TheMapData
    RedrawMap = True
End Sub

Sub LoadEditMap(TheMapData As String)
    Dim A As Long, X As Long, Y As Long
    If Len(TheMapData) = 2677 Then
        With EditMap
            MapData = TheMapData
            MapDataLoadingArray() = StrConv(MapData, vbFromUnicode)
            .name = ClipString$(Mid$(MapData, 1, 30))
            .Version = Asc(Mid$(MapData, 31, 1)) * 16777216 + Asc(Mid$(MapData, 32, 1)) * 65536 + Asc(Mid$(MapData, 33, 1)) * 256& + Asc(Mid$(MapData, 34, 1))
            .NPC = Asc(Mid$(MapData, 35, 1)) * 256 + Asc(Mid$(MapData, 36, 1))
            .MIDI = Asc(Mid$(MapData, 37, 1))
            .ExitUp = Asc(Mid$(MapData, 38, 1)) * 256 + Asc(Mid$(MapData, 39, 1))
            .ExitDown = Asc(Mid$(MapData, 40, 1)) * 256 + Asc(Mid$(MapData, 41, 1))
            .ExitLeft = Asc(Mid$(MapData, 42, 1)) * 256 + Asc(Mid$(MapData, 43, 1))
            .ExitRight = Asc(Mid$(MapData, 44, 1)) * 256 + Asc(Mid$(MapData, 45, 1))
            .BootLocation.Map = Asc(Mid$(MapData, 46, 1)) * 256 + Asc(Mid$(MapData, 47, 1))
            .BootLocation.X = Asc(Mid$(MapData, 48, 1))
            .BootLocation.Y = Asc(Mid$(MapData, 49, 1))
            .DeathLocation.Map = Asc(Mid$(MapData, 50, 1)) * 256 + Asc(Mid$(MapData, 51, 1))
            .DeathLocation.X = Asc(Mid$(MapData, 52, 1))
            .DeathLocation.Y = Asc(Mid$(MapData, 53, 1))
            .flags = Asc(Mid$(MapData, 54, 1))
            .Flags2 = Asc(Mid$(MapData, 55, 1))
            For A = 0 To 9    '56 - 86
                .MonsterSpawn(A).Monster = Asc(Mid$(MapData, 56 + A * 3)) * 256 + Asc(Mid$(MapData, 57 + A * 3))
                .MonsterSpawn(A).Rate = Asc(Mid$(MapData, 58 + A * 3))
            Next A
            '86
            For Y = 0 To 11
                For X = 0 To 11
                    With .Tile(X, Y)
                        A = 86 + Y * 216 + X * 18
                        '1-10 = Tiles
                        .Ground = Asc(Mid$(MapData, A, 1)) * 256 + Asc(Mid$(MapData, A + 1, 1))
                        .Ground2 = Asc(Mid$(MapData, A + 2, 1)) * 256 + Asc(Mid$(MapData, A + 3, 1))
                        .BGTile1 = Asc(Mid$(MapData, A + 4, 1)) * 256 + Asc(Mid$(MapData, A + 5, 1))
                        .BGTile2 = Asc(Mid$(MapData, A + 6, 1)) * 256 + Asc(Mid$(MapData, A + 7, 1))
                        .FGTile = Asc(Mid$(MapData, A + 8, 1)) * 256 + Asc(Mid$(MapData, A + 9, 1))
                        .FGTile2 = Asc(Mid$(MapData, A + 10, 1)) * 256 + Asc(Mid$(MapData, A + 11, 1))
                        .Att = Asc(Mid$(MapData, A + 12, 1))
                        .AttData(0) = Asc(Mid$(MapData, A + 13, 1))
                        .AttData(1) = Asc(Mid$(MapData, A + 14, 1))
                        .AttData(2) = Asc(Mid$(MapData, A + 15, 1))
                        .AttData(3) = Asc(Mid$(MapData, A + 16, 1))
                        .Att2 = Asc(Mid$(MapData, A + 17, 1))
                    End With
                Next X
            Next Y

            If ExamineBit(.flags, 1) = True Then
                Indoors = True
            Else
                Indoors = False
            End If

            If ExamineBit(.flags, 2) = True Then
                AlwaysDark = True
            Else
                AlwaysDark = False
            End If

        End With
    End If
End Sub

Function ExamineBit(bytByte As Byte, Bit As Byte) As Byte
    ExamineBit = ((bytByte And (2 ^ Bit)) > 0)
End Function

Public Function LoadMapData(data As String) As MapData
    Dim A As Long, X As Long, Y As Long, MapData As String, Map As MapData
    
    If Len(data) = 2677 Then
        
        MapData = data
        With Map
            .name = Mid$(MapData, 1, 30)
            .Version = Asc(Mid$(MapData, 31, 1)) * 16777216 + Asc(Mid$(MapData, 32, 1)) * 65536 + Asc(Mid$(MapData, 33, 1)) * 256& + Asc(Mid$(MapData, 34, 1))
            .NPC = Asc(Mid$(MapData, 35, 1)) * 256 + Asc(Mid$(MapData, 36, 1))
            .MIDI = Asc(Mid$(MapData, 37, 1))
            .ExitUp = Asc(Mid$(MapData, 38, 1)) * 256 + Asc(Mid$(MapData, 39, 1))
            .ExitDown = Asc(Mid$(MapData, 40, 1)) * 256 + Asc(Mid$(MapData, 41, 1))
            .ExitLeft = Asc(Mid$(MapData, 42, 1)) * 256 + Asc(Mid$(MapData, 43, 1))
            .ExitRight = Asc(Mid$(MapData, 44, 1)) * 256 + Asc(Mid$(MapData, 45, 1))
            .BootLocation.Map = Asc(Mid$(MapData, 46, 1)) * 256 + Asc(Mid$(MapData, 47, 1))
            .BootLocation.X = Asc(Mid$(MapData, 48, 1))
            .BootLocation.Y = Asc(Mid$(MapData, 49, 1))
            .DeathLocation.Map = Asc(Mid$(MapData, 50, 1)) * 256 + Asc(Mid$(MapData, 51, 1))
            .DeathLocation.X = Asc(Mid$(MapData, 52, 1))
            .DeathLocation.Y = Asc(Mid$(MapData, 53, 1))
            .flags = Asc(Mid$(MapData, 54, 1))
            .Flags2 = Asc(Mid$(MapData, 55, 1))
            For A = 0 To 9    '56 - 86
                .MonsterSpawn(A).Monster = Asc(Mid$(MapData, 56 + A * 3)) * 256 + Asc(Mid$(MapData, 57 + A * 3))
                .MonsterSpawn(A).Rate = Asc(Mid$(MapData, 58 + A * 3))
            Next A
            '86
            For Y = 0 To 11
                For X = 0 To 11
                    With .Tile(X, Y)
                        A = 86 + Y * 216 + X * 18
                        '1-10 = Tiles
                        .Ground = Asc(Mid$(MapData, A, 1)) * 256 + Asc(Mid$(MapData, A + 1, 1))
                        .Ground2 = Asc(Mid$(MapData, A + 2, 1)) * 256 + Asc(Mid$(MapData, A + 3, 1))
                        .BGTile1 = Asc(Mid$(MapData, A + 4, 1)) * 256 + Asc(Mid$(MapData, A + 5, 1))
                        .BGTile2 = Asc(Mid$(MapData, A + 6, 1)) * 256 + Asc(Mid$(MapData, A + 7, 1))
                        .FGTile = Asc(Mid$(MapData, A + 8, 1)) * 256 + Asc(Mid$(MapData, A + 9, 1))
                        .FGTile2 = Asc(Mid$(MapData, A + 10, 1)) * 256 + Asc(Mid$(MapData, A + 11, 1))
                        .Att = Asc(Mid$(MapData, A + 12, 1))
                        .AttData(0) = Asc(Mid$(MapData, A + 13, 1))
                        .AttData(1) = Asc(Mid$(MapData, A + 14, 1))
                        .AttData(2) = Asc(Mid$(MapData, A + 15, 1))
                        .AttData(3) = Asc(Mid$(MapData, A + 16, 1))
                        .Att2 = Asc(Mid$(MapData, A + 17, 1))
                    End With
                Next X
            Next Y

        End With
        Else
        MsgBox Len(data)
    End If
    LoadMapData = Map
    
    
End Function


Sub SaveMap(File As String)
    If Exists(File) Then
        If MsgBox("A map with that name already exists.  Saving will replace it.  Do you wish to continue?", vbYesNo + vbQuestion, TitleString) = vbYes Then
            On Error Resume Next
                Kill File
            On Error GoTo 0
        Else
            Exit Sub
        End If
    End If
    
    Dim TheMapData As String, St1 As String * 30
    Dim X As Long, Y As Long
    With Map
        St1 = .name
        TheMapData = St1 + QuadChar(.Version) + DoubleChar$(CLng(.NPC)) + Chr$(.MIDI) + DoubleChar$(CLng(.ExitUp)) + DoubleChar$(CLng(.ExitDown)) + DoubleChar$(CLng(.ExitLeft)) + DoubleChar$(CLng(.ExitRight)) + DoubleChar(CLng(.BootLocation.Map)) + Chr$(.BootLocation.X) + Chr$(.BootLocation.Y) + DoubleChar(CLng(.DeathLocation.Map)) + Chr$(.DeathLocation.X) + Chr$(.DeathLocation.Y)
        TheMapData = TheMapData + Chr$(.flags) + Chr$(.Flags2) + DoubleChar$(CLng(.MonsterSpawn(0).Monster)) + Chr$(.MonsterSpawn(0).Rate) + DoubleChar$(CLng(.MonsterSpawn(1).Monster)) + Chr$(.MonsterSpawn(1).Rate) + DoubleChar$(CLng(.MonsterSpawn(2).Monster)) + Chr$(.MonsterSpawn(2).Rate) + DoubleChar$(CLng(.MonsterSpawn(3).Monster)) + Chr$(.MonsterSpawn(3).Rate) + DoubleChar$(CLng(.MonsterSpawn(4).Monster)) + Chr$(.MonsterSpawn(4).Rate) + DoubleChar$(CLng(.MonsterSpawn(5).Monster)) + Chr$(.MonsterSpawn(5).Rate) + DoubleChar$(CLng(.MonsterSpawn(6).Monster)) + Chr$(.MonsterSpawn(6).Rate) + DoubleChar$(CLng(.MonsterSpawn(7).Monster)) + Chr$(.MonsterSpawn(7).Rate) + DoubleChar$(CLng(.MonsterSpawn(8).Monster)) + Chr$(.MonsterSpawn(8).Rate) + DoubleChar$(CLng(.MonsterSpawn(9).Monster)) + Chr$(.MonsterSpawn(9).Rate)
        For Y = 0 To 11
            For X = 0 To 11
                With .Tile(X, Y)
                    TheMapData = TheMapData + DoubleChar(CLng(.Ground)) + DoubleChar$(CLng(.Ground2)) + DoubleChar(CLng(.BGTile1)) + DoubleChar(CLng(.BGTile2)) + DoubleChar(CLng(.FGTile)) + DoubleChar(CLng(.FGTile2)) + Chr$(.Att) + Chr$(.AttData(0)) + Chr$(.AttData(1)) + Chr$(.AttData(2)) + Chr$(.AttData(3)) + Chr$(.Att2)
                End With
            Next X
        Next Y
    End With

    Open File For Output As #1 Len = 2677
    Print #1, TheMapData
    Close #1
End Sub

