Attribute VB_Name = "modUncompress"
Private Declare Function Compress Lib "odyzlib.dll" Alias "compress2" (ByRef DeStinationArray As Byte, ByRef destLen As Long, ByRef SourceArray As Byte, ByVal SourceLen As Long, ByVal CompressionLevel As Long) As Long
Private Declare Function ZCompress Lib "odyzlib.dll" Alias "compress" (dest As Byte, destLen As Any, src As Any, ByVal srcLen As Long) As Long
Private Declare Function ZUncompress Lib "odyzlib.dll" Alias "uncompress" (dest As Byte, destLen As Any, src As Any, ByVal srcLen As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDeSt As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function Uncompress Lib "odyzlib.dll" Alias "uncompress" (ByRef DeStinationArray As Byte, ByRef destLen As Long, ByRef SourceArray As Byte, ByVal SourceLen As Long) As Long
Public Function CompressString$(data, Optional key)
    Dim lKey As Long  'original size
    Dim sTmp As String  'String buffer
    Dim bData() As Byte  'data buffer
    Dim bRet() As Byte  'output buffer
    Dim lCSz As Long  'compressed size

    If TypeName(data) = "Byte()" Then    'if given byte array data
        bData = data  'copy to data buffer
    ElseIf TypeName(data) = "String" Then    'if given String data
        If Len(data) > 0 Then    'if there is data
            sTmp = data    'copy to String buffer
            ReDim bData(Len(sTmp) - 1)    'allocate data buffer
            CopyMemory bData(0), ByVal sTmp, Len(sTmp)    'copy to data buffer
            sTmp = vbNullString    'deallocate String buffer
        End If
    End If
    If StrPtr(bData) <> 0 Then    'if data buffer contains data
        lKey = UBound(bData) + 1    'get data size
        lCSz = lKey + (lKey * 0.01) + 12    'eStimate compressed size
        ReDim bRet(lCSz - 1)    'allocate output buffer
        Call ZCompress(bRet(0), lCSz, bData(0), lKey)    'compress data (lCSz returns actual size)
        ReDim Preserve bRet(lCSz - 1)    'resize output buffer to actual size
        Erase bData    'deallocate data buffer
        If IsMissing(key) Then    'if Key variable not supplied
            ReDim bData(lCSz + 3)    'allocate data buffer
            CopyMemory bData(0), lKey, 4    'copy key to buffer
            CopyMemory bData(4), bRet(0), lCSz    'copy data to buffer
            Erase bRet    'deallocate output buffer
            bRet = bData    'copy to output buffer
            Erase bData    'deallocate data buffer
        Else    'Key variable is supplied
            key = lKey    'set Key variable
        End If
        If TypeName(data) = "Byte()" Then    'if given byte array data
            CompressString = bRet    'return output buffer
        ElseIf TypeName(data) = "String" Then    'if given String data
            sTmp = Space(UBound(bRet) + 1)    'allocate String buffer
            CopyMemory ByVal sTmp, bRet(0), UBound(bRet) + 1    'copy to String buffer
            CompressString = sTmp    'return String buffer
            sTmp = vbNullString    'deallocate String buffer
        End If
        Erase bRet    'deallocate output buffer
    End If
End Function
Public Function UncompressString$(data, Optional ByVal key)
    Dim lKey As Long  'original size
    Dim sTmp As String  'String buffer
    Dim bData() As Byte  'data buffer
    Dim bRet() As Byte  'output buffer
    Dim lCSz As Long  'compressed size

    If TypeName(data) = "Byte()" Then    'if given byte array data
        bData = data    'copy to data buffer
    ElseIf TypeName(data) = "String" Then    'if given String data
        If Len(data) > 0 Then    'if there is data
            sTmp = data    'copy to String buffer
            ReDim bData(Len(sTmp) - 1)    'allocate data buffer
            CopyMemory bData(0), ByVal sTmp, Len(sTmp)    'copy to data buffer
            sTmp = vbNullString    'deallocate String buffer
        End If
    End If
    If StrPtr(bData) <> 0 Then    'if there is data
        If IsMissing(key) Then    'if Key variable not supplied
            lCSz = UBound(bData) - 3    'get actual data size
            CopyMemory lKey, bData(0), 4    'copy key value to key
            ReDim bRet(lCSz - 1)    'allocate output buffer
            CopyMemory bRet(0), bData(4), lCSz    'copy data to output buffer
            Erase bData    'deallocate data buffer
            bData = bRet    'copy to data buffer
            Erase bRet    'deallocate output buffer
        Else    'Key variable is supplied
            lCSz = UBound(bData) + 1    'get data size
            lKey = key    'get Key
        End If
        ReDim bRet(lKey - 1)    'allocate output buffer
        Call ZUncompress(bRet(0), lKey, bData(0), lCSz)    'decompress to output buffer
        Erase bData    'deallocate data buffer
        If TypeName(data) = "Byte()" Then    'if given byte array data
            UncompressString = bRet    'return output buffer
        ElseIf TypeName(data) = "String" Then    'if given String data
            sTmp = Space(lKey)    'allocate String buffer
            CopyMemory ByVal sTmp, bRet(0), lKey    'copy to String buffer
            UncompressString = sTmp    'return String buffer
            sTmp = vbNullString    'deallocate String buffer
        End If
        Erase bRet    'deallocate return buffer
    End If
End Function

